Program Fill_2Pef

  use sep
  use nhelix
  use io_nfilt
  use fill_2pefe
  use read_hist_param
  use error_check
  use nbound_bob_mod
  implicit none

  integer                           :: nm,ndat,fiter,fprec,stat
  real                              :: feps,fsig
  integer, dimension(:),allocatable :: nn
  real,    dimension(:),pointer     :: oo,dd,data,mask,points,model
  real,    dimension(:,:),pointer   :: coord
  logical, dimension(:),pointer     :: maskl
  type(nfilter)                     :: pef1, pef2
  logical                           :: prec,grid
  character(len=1024)               :: fname1,fname2

write(0,*)"Fill start"

  call sep_init(SOURCE)
  dim = sep_dimension()

write(0,*)"Fill start2"
  allocate(nn(dim),oo(dim),dd(dim))
  
  call history_read(nn,oo,dd)
  call from_param("filt1",fname1,'pef1.H')
  call from_param("filt2",fname2,'pef2.H')
  call from_param ("feps",feps,0.1)
  call from_param ("fiter",fiter,100)
  

write(0,*)"Fill par read",nn,oo,dd

  ndat=product(nn)
  allocate(data(ndat),mask(ndat),model(ndat),maskl(ndat))

  call sep_read(data)
  call sep_read(mask,"mask")
  stat=read_nfilt(fname1,pef1)
  call nbound_bob(nn,pef1)
  stat=read_nfilt(fname2,pef2)
  call nbound_bob(nn,pef2)

write(0,*)"Fill data, mask and pef read"
call pefcheck(pef1)
call pefcheck(pef2)
  maskl=.false.
  where (mask>0) maskl=.true.
  deallocate(mask)

write(0,*)"Fill change mask"

  call fill_2grid(pef1,pef2,data,maskl,model,feps,fiter)

     write(0,*)"Fill after main call"
     call rmms(model,"model")
     call sep_write(model)
     call sep_close()
     deallocate(data,model,maskl,nn,oo,dd)
     call ndeallocate(pef1)
     call ndeallocate(pef2)
  
   end Program Fill_2Pef
