Program Ndiv

use sep
use nhelix
use createnhelixmod
use nbound_bob_mod
use npolydiv
use io_nfilt
use nsfill

  implicit none
  integer                              :: n1, n2, n3, a1, a2, a3, niter, nsc, na, i, linflt, dim
  integer, external                    :: getch
  integer, dimension (:), pointer      :: sc, a, ndat, patch, fakepatch,tmppch
  integer                              :: tt(1000)
  real, dimension (:), pointer         :: indata, outdata, k0, killdata, dummask
  integer, dimension (:), allocatable  :: center, gap, psize, pos, cartflt
  real, dimension (:), pointer         :: ddat, odat, wei
  real                                 :: d1, d2, d3, o1, o2, o3, eps
  logical                              :: rad, readstat, stat, lmask(:)
  type(nfilter)                        :: aa
  character(len=1024)                  :: filt

  call sep_init(SOURCE)
  dim = sep_dimension()
! Read history of data
  call from_history( "n1", n1);       call from_history( "n2", n2);       call from_history( "n3", n3)
  call from_history( "d1", d1, 1.0);  call from_history( "d2", d2, 1.0);  call from_history( "d3", d3, 1.0)
  call from_history( "o1", o1, 0.0);  call from_history( "o2", o2, 0.0);  call from_history( "o3", o3, 0.0)
  call to_history( "n", (/n1,n2/) )
  call from_param ("filt",filt,'filt.H')
  call from_param ("niter",niter,100)
write(0,*)"test1"

  allocate(ndat(dim), a(dim), ddat(dim), odat(dim), center(dim), gap(dim), patch(dim), fakepatch(dim) )
  ndat = (/n1,n2/);
  allocate( indata(product(ndat)), outdata(product(ndat)))
  outdata=0
write(0,*)"test2,ndat",ndat
  call sep_read( indata )
write(0,*)"test3"
  readstat = read_nfilt(filt,aa)
write(0,*)"filter info:"
write(0,*)"filter npatch:",size(aa%hlx)
write(0,*)"filter datasize:",size(aa%pch)
write(0,*)"filter lags:",aa%hlx(1)%lag
! allocate filter
  call nbound_bob( ndat, aa)
  call npolydiv_init(product(ndat),aa)
  stat=npolydiv_lop(.false.,.false.,indata,outdata)
  call sep_write (outdata)
  call sep_close ()
  deallocate( indata,outdata)
  call ndeallocate(aa)
  deallocate (ndat) 
  call exit (0)
end program Ndiv
