module nheliconx2

  use adj_mod
  use nhelicon1
  use nhelicon2
  use nhelix
  use chain_mod
  implicit none

    integer          :: nd


  contains
  subroutine nheliconx2_init (pef1_in,pef2_in,nd_in)
    type(nfilter)    ::    pef1_in,pef2_in
    integer          ::                       nd_in
write(0,*)"PEF 1 lags:",pef1_in%hlx(1)%lag
    call nhelicon1_init(pef1_in)
write(0,*)"PEF 2 lags:",pef2_in%hlx(1)%lag
    call nhelicon2_init(pef2_in)
    nd=nd_in
  end subroutine
  function nheliconx2_lop ( adj, add, xx, yy) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: xx,yy 
    call adjnull (adj,add,xx,yy )
    call nheliconx2_lop2(adj,xx,yy )
    stat=0
  end function 
  subroutine nheliconx2_lop2(adj,xx,yy)
    logical,intent(in) :: adj 
    real, dimension (:)  :: xx 
    real, dimension (:)  :: yy 
!write(0,*)"mad2pef lop",nd,size(xx),size(yy)
!    call array(nhelicon1_lop,nhelicon2_lop,adj,.true.,xx,yy(1:nd),yy(nd+1:2*nd))
    call array(nhelicon1_lop,nhelicon2_lop,adj,.true.,xx,yy,yy)
  end subroutine 
  subroutine nheliconx2_close()
    call nhelicon1_close()
    call nhelicon2_close()
  end subroutine 
end module nheliconx2
