module peff2

  use adj_mod
  use helicon
  use helicon2
  use helix
  use chain_mod
  implicit none
  contains
  subroutine peff2_init (pef1_in,pef2_in)
    type( filter)    ::    pef1_in,pef2_in
    call helicon_init(pef1_in)
    call helicon2_init(pef2_in)
  end subroutine
  function peff2_lop ( adj, add, xx, yy) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: xx,yy 
    call adjnull (adj,add,xx,yy )
    call peff2_lop2(adj,xx,yy )
    stat=0
  end function 
  subroutine peff2_lop2(adj,xx,yy)
    logical,intent(in) :: adj 
    real, dimension (:)  :: xx 
    real, dimension (:)  :: yy 
!write(0,*)"mad2pef lop",nd,size(xx),size(yy)
    call array(helicon_lop,helicon2_lop,adj,.true.,xx,yy,yy)
  end subroutine 
  subroutine peff2_close()
    call helicon_close()
    call helicon2_close()
  end subroutine 
end module 
