Program Cmp2sg
  
  use sep
  use read_hist_param

  implicit none
  integer                            :: i,j,k,l,dim, n(3),fn(3), ng, ns, p
  real                               :: cmp,aoffset,rec,src,rmin,rmax,smin,smax,o(3),d(3),fo(3),fd(3)
  real, dimension(:,:,:),allocatable :: data, output

  call sep_init(SOURCE)
  dim = sep_dimension()

  call history_read(n,o,d)

  call from_param("ng",ng,200)
  call from_param("ns",ns,200)

  call from_param("recip",p,0)

  fn(1)=n(1)
  fn(2)=ng
  fn(3)=ns

  rmin=o(2)-(o(3)+d(3)*(n(3)-1))
  rmax=(o(2)+d(2)*(n(2)-1))-o(3)
  smin=o(2)+o(3)
  smax=(o(2)+d(2)*(n(2)-1))+(o(3)+d(3)*(n(3)-1))

  fo(1)=o(1)
  fo(2)=rmin
  if (p) then
     fo(3)=rmin 
  else
     fo(3)=smin
  end if
  fd(1)=d(1)
  if (p) then
     fd(2)=(smax-rmin)/(fn(2)-1)
     fd(3)=(smax-rmin)/(fn(3)-1)
  else
     fd(2)=(rmax-rmin)/(fn(2)-1)
     fd(3)=(smax-smin)/(fn(3)-1)
  end if
  call hist_nod(fn,fo,fd)
  call to_history("label1","time (s)")
  call to_history("label2","g_x")
  call to_history("label3","s_x")

write(0,*)"fd",fd
write(0,*)"fo",fo

  allocate(data(n(1),n(2),n(3)),output(fn(1),fn(2),fn(3)))

  call sep_read( data )

  do i=1,n(2)
     do j=1,n(3)
        cmp=o(2)+d(2)*(i-1)
        aoffset=o(3)+d(3)*(j-1)
        rec=cmp-aoffset
        src=cmp+aoffset
        k=nint(((rec-fo(2))/fd(2))+0.5)
        l=nint(((src-fo(3))/fd(3))+0.5)
        output(:,k,l)=data(:,i,j)
        if (p) then
           k=nint(((src-fo(2))/fd(2))+0.5)
           l=nint(((rec-fo(3))/fd(3))+0.5)
           output(:,k,l)=data(:,i,j)
        end if
     end do
  end do

  call sep_write(output)
  call sep_close ()
  deallocate(output,data)
  call exit ()

end Program Cmp2sg
