Program Find_mask

  use sep
  use read_hist_param
  implicit none

  integer                                    :: i,p,dim
  integer, dimension(:),         allocatable :: nn
  real,    dimension(:),         allocatable :: oo, dd, data, mask
  real,    dimension(:,:),       allocatable :: dat2, mask2, temp2
  real,    dimension(:,:,:),     allocatable :: dat3, mask3, temp3
  real,    dimension(:,:,:,:),   allocatable :: dat4, mask4, temp4
  real,    dimension(:,:,:,:,:), allocatable :: dat5, mask5, temp5


  call sep_init(SOURCE)
  dim = sep_dimension()
  allocate(nn(dim),oo(dim),dd(dim))

  call history_read(nn,oo,dd)
  call from_param("p",p,nn(1))

  allocate(data(product(nn)),mask(product(nn)))
  call sep_read(data)

  if (dim==2) then
     allocate(dat2(nn(1),nn(2)),mask2(nn(1),nn(2)),temp2(1,nn(2)))
     dat2=reshape(data,(/nn(1),nn(2)/))
     where (dat2(p,:)/=0)
        temp2(1,:)=1
     elsewhere
        temp2(1,:)=0
     end where
     do i=1,nn(1)
        mask2(i,:)=temp2(1,:)
     end do
     mask=reshape(mask2,(/product(nn)/))
     deallocate(dat2,mask2,temp2)
     
  elseif (dim==3) then
     allocate(dat3(nn(1),nn(2),nn(3)),mask3(nn(1),nn(2),nn(3)),temp3(1,nn(2),nn(3)))
     dat3=reshape(data,(/nn(1),nn(2),nn(3)/))
     where (dat3(p,:,:)/=0)
        temp3(1,:,:)=1
     elsewhere
        temp3(1,:,:)=0
     end where
     do i=1,nn(1)
        mask3(i,:,:)=temp3(1,:,:)
     end do
     mask=reshape(mask3,(/product(nn)/))
     deallocate(dat3,mask3,temp3)
     
  elseif (dim==4) then
     allocate(dat4(nn(1),nn(2),nn(3),nn(4)),mask4(nn(1),nn(2),nn(3),nn(4)),temp4(1,nn(2),nn(3),nn(4)))
     dat4=reshape(data,(/nn(1),nn(2),nn(3),nn(4)/))
     where (dat4(p,:,:,:)/=0)
        temp4(1,:,:,:)=1
     elsewhere
        temp4(1,:,:,:)=0
     end where
     do i=1,nn(1)
        mask4(i,:,:,:)=temp4(1,:,:,:)
     end do
     mask=reshape(mask4,(/product(nn)/))
     deallocate(dat4,mask4,temp4)

  elseif (dim==5) then
     allocate(dat5(nn(1),nn(2),nn(3),nn(4),nn(5)),mask5(nn(1),nn(2),nn(3),nn(4),nn(5)),temp5(1,nn(2),nn(3),nn(4),nn(5)))
     dat5=reshape(data,(/nn(1),nn(2),nn(3),nn(4),nn(5)/))
     where (dat5(p,:,:,:,:)/=0)
        temp5(1,:,:,:,:)=1
     elsewhere
        temp5(1,:,:,:,:)=0
     end where
     do i=1,nn(1)
        mask5(i,:,:,:,:)=temp5(1,:,:,:,:)
     end do
     mask=reshape(mask5,(/product(nn)/))
     deallocate(dat5,mask5,temp5)
     
  endif

  call sep_write(mask)

end Program Find_mask
