Program Interp_nspef

  use sep
  use nhelix
  use io_nfilt
  use fill_ns
  use read_hist_param
  use error_check
  use rescale_bill
  use nbound_bob_mod
  implicit none

  integer                           :: nm,ndat,fiter,fprec,stat
  real                              :: feps,fsig
  integer, dimension(:),allocatable :: nn,fn
  real,    dimension(:),pointer :: oo,dd,fo,fd,data,mask,points,model,ildata
  real,    dimension(:,:),pointer   :: coord
  logical, dimension(:),pointer :: maskl
  type(nfilter)                     :: pef
  logical                           :: prec,grid
  character(len=1024)               :: fname

write(0,*)"Fill start"

  call sep_init(SOURCE)
  dim = sep_dimension()

write(0,*)"Fill start2"
  allocate(nn(dim),oo(dim),dd(dim),fn(dim),fo(dim),fd(dim))
  
  call history_read(nn,oo,dd)
  call fillpar_read(fname,feps,fsig,fiter,fprec)
  call fillgpar_read(fn,fo,fd)
  call from_param("grid",grid,.true.)
  call to_history("n",fn)
  call to_history("o",fo)
  call to_history("d",fd)

write(0,*)"Fill par read",nn,oo,dd

!fn=nn;fo=oo;fd=dd
  ndat=product(nn); nm=product(fn)
  allocate(data(ndat),mask(nm),points(ndat),coord(ndat,dim),model(nm),maskl(nm),ildata(nm))

  call sep_read(data)
  
  stat=read_nfilt(fname,pef)

  maskl=.false.

! need to fix pef patch as well as mis

write(0,*)"filt read",nn,fn

  call interlace_data(data,ildata,nn,fn)
write(0,*)"ilace_data"
  call interlace_mask(nn,fn,maskl)   
  call interlace_pef(pef,nn,fn)  


write(0,*)"Fill data, mask and pef read"
call pefcheck(pef)
  prec=.false.
  if (fprec==1) prec=.true.

write(0,*)"Fill change mask"



  if (grid==0) then
     call bin2points(ildata,nn,oo,dd,maskl,points,coord)
     write(0,*)"Fill after bin2points",fiter
     call lmms(maskl,"maskl")
     call rmms(data,"data ")
     call rmms(points,"point")
     call rmms2(coord,"coord")
     call pefcheck(pef)
     call fill(pef,points,coord,model,fn,fo,fd,prec,fsig,feps,fiter)
  else
     write(0,*)"before fill_grid"

     call lmms(maskl,"maskl")
     call rmms(ildata,"idata")
     call rmms(model,"model")
     call fill_grid(pef,ildata,maskl,model,prec,fsig,feps,fiter)
  end if

     write(0,*)"Fill after main call"
     call rmms(model,"model")
     call sep_write(model)
     call sep_close()
     deallocate(data,points,coord,model,maskl,nn,oo,dd,fn,fo,fd)
     call ndeallocate(pef)
  
   end Program Interp_nspef
